<template>
  <div style="width: 100%">
    <div class="fs-18">
      <svg width="8" height="14" viewBox="0 0 8 14" fill="none" xmlns="http://www.w3.org/2000/svg">
<path d="M-0.000704364 12.5276L-0.00070533 1.47068C-0.000705397 0.705061 0.89692 0.321651 1.42188 0.863014L6.78279 6.39146C7.10821 6.72704 7.10821 7.2712 6.78279 7.60679L1.42188 13.1352C0.896921 13.6766 -0.000704297 13.2932 -0.000704364 12.5276Z" fill="#31C1E0"/>
</svg>
 TREND ALERT TEMPLATE

      <div style="float: right; font-size: 12px">
        <button class="btn btn-link d-flex align-items-center" @click="changeTemplate">
          <svg width="18" height="18" viewBox="0 0 18 18" fill="none" xmlns="http://www.w3.org/2000/svg">
<path d="M3.5385 11.9843C2.7435 11.1893 2.25 10.0928 2.25 8.88675C2.25 6.474 4.224 4.5 6.63675 4.5L12 4.51575" stroke="#1B6EA0" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"/>
<path d="M10.5 6.01562L12 4.51562L10.5 3.01562" stroke="#1B6EA0" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"/>
<path d="M14.4615 6.01562C15.2565 6.81062 15.75 7.90713 15.75 9.11313C15.75 11.5259 13.776 13.4999 11.3633 13.4999L6 13.4841" stroke="#1B6EA0" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"/>
<path d="M7.5 11.9844L6 13.4844L7.5 14.9844" stroke="#1B6EA0" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"/>
</svg>
 Change template
        </button>
      </div>
    </div>

    <!-- <div class="builder-panel_timeLine">
      <ul>
        <li>
          <div class="circle active">we</div>
          Weeky Report
        </li>
        <li>
          <div class="circle">en</div>
          Email Newsletters
        </li>
        <li>
          <div class="circle">de</div>
          Dedicated Emails.
        </li>
        <li>
          <div class="circle">lne</div>
          Lead Nurturing Emails
        </li>
      </ul>
      <div class="builder-panel_view">View all</div>
    </div> -->

    <div style="width: 100%" ref="content">
      <!-- <app-default-theme></app-default-theme> -->
      <app-weekly-top-pics-theme></app-weekly-top-pics-theme>
      <!-- <app-happy-new-year-theme></app-happy-new-year-theme> -->
    </div>

    <div
      class="text-right"
      style="width: 100%; padding: 10px; display: flex; align-items: center; justify-content: flex-end;"
    >
      <!-- <select
        style="padding: 7px;
    border: 1px solid #c8c8c8;
    border-radius: 3px;"
        v-model="selectStyEmail"
      >
        <option value="Responsive Email">Responsive Email</option>
        <option value="Scaled Email">Scaled Email</option>
      </select> -->

      <label class="Radio mb-0" for="responsive_radio">
        <input
          class="Radio-Input"
          v-model="selectStyEmail"
          type="radio"
          id="responsive_radio"
          checked
          name="radio"
          value="Responsive Email"
        />
        Responsive Email
      </label>

      <label class="Radio mb-0" for="scaled_radio">
        <input
          class="Radio-Input"
          v-model="selectStyEmail"
          type="radio"
          id="scaled_radio"
          name="radio"
          value="Scaled Email"
        />
        Scaled Email
      </label>

      <button
        type="button"
        class="btn btn-default d-flex align-items-center"
        style="margin: 10px"
        @click="viewHtml"
      >
        <svg width="19" height="14" viewBox="0 0 19 14" fill="none" xmlns="http://www.w3.org/2000/svg">
<path d="M1.23185 8.00212C1.08238 7.81035 1.00083 7.57437 1.00001 7.33123C0.999186 7.08809 1.07914 6.85156 1.22732 6.65878C2.37284 5.15674 5.46988 1.66406 9.50216 1.66406C13.4812 1.66406 16.6077 5.15447 17.7691 6.65765C17.9192 6.85045 18.0007 7.08781 18.0007 7.33215C18.0007 7.5765 17.9192 7.81386 17.7691 8.00666C16.6077 9.50983 13.4812 13.0002 9.50216 13.0002C5.52316 13.0002 2.39041 9.5019 1.23185 8.00212Z" stroke="#333" stroke-width="1.5" stroke-miterlimit="10" stroke-linecap="square"/>
<path d="M9.50242 10.7333C11.3807 10.7333 12.9033 9.21074 12.9033 7.3325C12.9033 5.45426 11.3807 3.93164 9.50242 3.93164C7.62418 3.93164 6.10156 5.45426 6.10156 7.3325C6.10156 9.21074 7.62418 10.7333 9.50242 10.7333Z" stroke="#333" stroke-width="1.5" stroke-miterlimit="10" stroke-linecap="square"/>
</svg>
 <span style="margin-left:5px">View HTML</span>
      </button>
      <!-- <button type="button" class="btn btn-primary" style="margin: 10px;">Save</button> -->
      <button
        class="btn btn-primary"
        role="button"
        style="margin-right: 10px"
        @click="saveTemplate"
      >
        Save
      </button>
      <button class="btn btn-primary" role="button" @click="loadTemplate">
        Load
      </button>
    </div>
  </div>
</template>

<script>
// import DefaultTheme from "../themes/Default";
import WeeklyTopPicsTheme from "../themes/WeeklyTopPics";
// import HappyNewYearTheme from "../themes/HappyNewYear";

import { ModalBus } from "../eventBus";
import ChangeTemplate from "@/components/ChangeTemplate";
import ViewHTML from "@/components/ViewHTML";
import SaveTemplate from "@/components/SaveTemplate";
import LoadTemplate from "@/components/LoadTemplate";
import $ from "jquery";
import { htmlView } from "../utils/viewHtml/responsiveEmail/index";
import { scaleEmail } from "../utils/viewHtml/scaledEmail/index";
import { mapGetters } from "vuex";
import Confirm from "../components/Confirm";
import Alert from "@/components/Alert";
import _ from "lodash";

export default {
  data: function() {
    return {
      theme: "default",
      selectStyEmail: "Responsive Email"
    };
  },
  components: {
    // appDefaultTheme: DefaultTheme,
    appWeeklyTopPicsTheme: WeeklyTopPicsTheme
    // appHappyNewYearTheme: HappyNewYearTheme,
  },
  created() {
    if (localStorage.getItem("savedata")) {
      this.selectStyEmail = JSON.parse(localStorage.getItem("savedata")).theme;
    }
  },
  mounted() {
    if (this.selectStyEmail != this.GETTER_THEME_EMAIL) {
      this.selectStyEmail = this.GETTER_THEME_EMAIL;
    }
  },
  watch: {
    selectStyEmail() {
      this.$store.dispatch("ACTION_CHANGE_THEME_EMAIL", this.selectStyEmail);
    }
  },
  computed: {
    ...mapGetters([
      "GETTER_THEME_EMAIL",
      "GETTER_DATA_BANNER",
      "GETTER_DATA_TOP_PICK",
      "GETTER_TOP_PICK",
      "GETTER_TITLE_TOP_PICK",
      "GETTER_DATA_BLOGGER_NAME_ENABLE",
      "GETTER_DATA_PRODUCT_OF_ROW",
      "GETTER_DATA_BLOGGER_CTA_ENABLE"
    ])
  },
  methods: {
    changeTemplate() {
      ModalBus.$emit("open", {
        component: ChangeTemplate,
        title: "Choose template is currently under construction!",
        mode: "fiftyPercent"
      });
    },
    viewHtml() {
      let check = true;
      let dataTopPick = _.chunk(this.GETTER_DATA_TOP_PICK, 3);
      console.log(dataTopPick);
      dataTopPick.forEach(element => {
        let dataTopPickHaveId = element.filter(e => e.blogger_name != null);
        if (dataTopPickHaveId.length % 3 != 0 && dataTopPickHaveId.length > 0) {
          check = false;
        }
      });
      if (check) {
        let data = {
          banner: this.GETTER_DATA_BANNER,
          dataTopPick: this.GETTER_DATA_TOP_PICK,
          topPick: this.GETTER_TOP_PICK,
          titleTopPick: this.GETTER_TITLE_TOP_PICK,
          theme: this.GETTER_THEME_EMAIL,
          nameBloggerEnable: this.GETTER_DATA_BLOGGER_NAME_ENABLE,
          productOfRow: this.GETTER_DATA_PRODUCT_OF_ROW,
          blogger_cta: this.GETTER_DATA_BLOGGER_CTA_ENABLE
        };
        localStorage.setItem("savedata", JSON.stringify(data));
        this.$router.push(`/htmlview?type=${this.GETTER_THEME_EMAIL}`);
      } else {
        let props = {};
        props.type = "warning";
        props.text = "This template required exactly 3 bloggers per each row. Please update it";
        ModalBus.$emit("open", {
          component: Alert,
          title: "Warning",
          mode: "thirtyPercent",
          props
        });
      }
    },
    saveTemplate() {
      ModalBus.$emit("open", {
        component: SaveTemplate,
        title: "Save your email",
        mode: "fiftyPercent"
      });
    },
    loadTemplate() {
      ModalBus.$emit("open", {
        component: LoadTemplate,
        title: "Load your email",
        mode: "fiftyPercent"
      });
    },
    addStyle: function(emailContent) {
      let emailKey =
        emailContent.find(".emailHeader").length > 0
          ? Object.keys(emailContent.find(".emailHeader")[0].dataset)[0]
          : "<>";
      let bloggerKey =
        emailContent.find(".blogger").length > 0
          ? Object.keys(emailContent.find(".blogger")[0].dataset)[0]
          : "<>";

      document.styleSheets.forEach(styleSheet => {
        if (
          !styleSheet.href ||
          styleSheet.href.includes(window.location.hostname)
        ) {
          styleSheet.cssRules.forEach(cssRule => {
            if (
              cssRule.cssText.includes(emailKey) ||
              cssRule.cssText.includes(bloggerKey)
            )
              emailContent.find(cssRule.selectorText).each(function() {
                $(this).attr(
                  "style",
                  ($(this).attr("style") || "") +
                    cssRule.cssText
                      .replace(cssRule.selectorText, "")
                      .replace("{", "")
                      .replace("}", "")
                      .replace(/"/g, "'")
                );
              });
          });
        }
      });
    }
  }
};
</script>
<style scoped>
.Radio {
  display: inline-flex;
  align-items: center;
}

.Radio-Input {
  margin: 0 0.5rem 0;
}
</style>
